Option Strict Off
Option Explicit On
Imports Microsoft.VisualBasic.PowerPacks
Friend Class Form1
    Inherits System.Windows.Forms.Form

    Dim formdone As Boolean
	
	'*****************************************************************
	'
	'For DI-148/158/710 series support, please visit www.ultimaserial.com first
	'
	'*****************************************************************
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		'For DI-148/158/710 series support, please visit www.ultimaserial.com first
		
		DeviceList.Items.Add("150RS") 'List of supported data acquisition devices
		DeviceList.Items.Add("151RS")
		DeviceList.Items.Add("194")
		DeviceList.Items.Add("195B")
		DeviceList.Items.Add("190")
		DeviceList.Items.Add("154RS")
		DeviceList.Items.Add("158")
		DeviceList.Items.Add("148")
		
		ComPort.Items.Add("1") 'List of supported COMM port
		ComPort.Items.Add("2")
		ComPort.Items.Add("3")
		ComPort.Items.Add("USB")
		
		TriggerChannel.Items.Add("0 - AnalogCh1") 'List of supported trigger chanels
		TriggerChannel.Items.Add("1 - AnalogCh2")
		TriggerChannel.Items.Add("2 - AnalogCh3")
		TriggerChannel.Items.Add("3 - AnalogCh4")
		TriggerChannel.Items.Add("100 - Digital0")
		TriggerChannel.Items.Add("101 - Digital1")
		TriggerChannel.Items.Add("102 - Digital2")
		TriggerChannel.Items.Add("200 - L2HEvent0")
		TriggerChannel.Items.Add("201 - L2HEvent1")
		TriggerChannel.Items.Add("203 - L2HEvent2")
		TriggerChannel.Items.Add("300 - H2LEvent0")
		TriggerChannel.Items.Add("301 - H2LEvent1")
		TriggerChannel.Items.Add("302 - H2LEvent2")
		
		TriggerMethod.Items.Add("0 - NoCondition") 'List of supported trigger methods
		TriggerMethod.Items.Add("1 - OnEdgeLow2High")
		TriggerMethod.Items.Add("2 - OnEdgeHigh2Low")
		TriggerMethod.Items.Add("3 - WhenAboveLevel")
        TriggerMethod.Items.Add("4 - WhenBelowLevel")

        formdone = True
		
	End Sub
	
    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click

        Label3.Text = "" 'Clear the text
        UltimaSerial.Device = Val(DeviceList.Text)
        UltimaSerial.Key = "?????" 'If you are using DI-194, you need to enter the key here
        UltimaSerial.CommPort = Val(ComPort.Text)
        UltimaSerial.ChannelCount = Val(ChannelCount.Text)
        UltimaSerial.TriggerChannel = Val(TriggerChannel.Text)
        UltimaSerial.AcquisitionMode = Val(TriggerMethod.Text)
        If Check1.CheckState = False Then
            UltimaSerial.TriggerLevel = Val(Text2.Text) 'Trigger level in count
        Else
            UltimaSerial.TriggerLevel = Val(Text2.Text) * 3276.8 'Trigger level in volt
        End If
        UltimaSerial.PreTriggerLength = Val(Text1.Text) 'Trigger point at the center of the chart
        UltimaSerial.PostTriggerLength = DQChart1.Xmax - Val(Text1.Text)

        UltimaSerial.SampleRate = Val(Text3.Text)
        UltimaSerial.EventLevel = 2 'Chart it when we have 2 or more points.
        UltimaSerial.Start()

        Timer1.Enabled = True

        Label31.Text = UltimaSerial.SerialNumber
        ChannelCount.Text = CStr(UltimaSerial.ChannelCount)
        Text3.Text = CStr(UltimaSerial.SampleRate)
    End Sub
	
	Private Sub Label25_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Label25.Click
		UltimaSerial.ResetCounter(ULTIMASERIALLib.enumDChn.Dig0, ULTIMASERIALLib.enumEdge.Low2High)
	End Sub
	
	Private Sub Label26_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Label26.Click
		UltimaSerial.ResetCounter(ULTIMASERIALLib.enumDChn.Dig1, ULTIMASERIALLib.enumEdge.Low2High)
		
	End Sub
	
	Private Sub Label27_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Label27.Click
		UltimaSerial.ResetCounter(ULTIMASERIALLib.enumDChn.Dig2, ULTIMASERIALLib.enumEdge.Low2High)
		
	End Sub
	
	Private Sub Label28_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Label28.Click
		UltimaSerial.ResetCounter(ULTIMASERIALLib.enumDChn.Dig0, ULTIMASERIALLib.enumEdge.High2Low)
		
	End Sub
	
	Private Sub Label29_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Label29.Click
		UltimaSerial.ResetCounter(ULTIMASERIALLib.enumDChn.Dig1, ULTIMASERIALLib.enumEdge.High2Low)
		
	End Sub
	
	
	
	Private Sub Label30_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Label30.Click
		UltimaSerial.ResetCounter(ULTIMASERIALLib.enumDChn.Dig2, ULTIMASERIALLib.enumEdge.High2Low)
		
	End Sub
	
	'UPGRADE_WARNING: Event Text1.TextChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
    Private Sub Text1_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Text1.TextChanged
        If formdone = False Then Exit Sub
        If Val(Text1.Text) < 0 Then Text1.Text = CStr(0) 'Pretrigger length can't be a negative number
        If Val(Text1.Text) > DQChart1.Xmax Then Text1.Text = CStr(DQChart1.Xmax) 'This way we can plot the whole triggered waveform on the chart
    End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
        Dim r As Double
		Dim f As Short
		If UltimaSerial.TriggerStatus = 0 Then
			Shape2.FillColor = System.Drawing.ColorTranslator.FromOle(&HFFFFFF)
			Label32.Text = "Pre-Trigger"
		ElseIf UltimaSerial.TriggerStatus < 3 Then 
			Shape2.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF00)
			Label32.Text = "Waiting for crossing"
		ElseIf UltimaSerial.TriggerStatus = 3 Then 
			Shape2.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF00FF)
			Label32.Text = "Post-Trigger"
		ElseIf UltimaSerial.TriggerStatus = 4 Then 
			Shape2.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF)
			Label32.Text = "Trigger done"
		End If
		'The following is taking continous snap shots of the data to give an illusion of scrolling waveform
		DQChart2.Chart(UltimaSerial.GetDataFrame(DQChart2.Xmax))
		
		'Here is for the readings
		f = UltimaSerial.AnalogInput(ULTIMASERIALLib.enumAChn.Ch1) 'The binary reading from Channel 0
		f = f / 16 'Assuming 12-bit resolution. The data is left-justified
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		r = f / 204.8 'Convert to Volt, assuming +/-10 Volt input range here
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		Label1.Text = VB6.Format(r, "#0.000") & "Volt"
		
		f = UltimaSerial.AnalogInput(ULTIMASERIALLib.enumAChn.Ch2) 'The binary reading from Channel 0
		f = f / 16 'Assuming 12-bit resolution. The data is left-justified
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		r = f / 204.8 'Convert to Volt, assuming +/-10 Volt input range here
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		Label4.Text = VB6.Format(r, "#0.000") & "Volt"
		
		f = UltimaSerial.AnalogInput(ULTIMASERIALLib.enumAChn.Ch3) 'The binary reading from Channel 0
		f = f / 16 'Assuming 12-bit resolution. The data is left-justified
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		r = f / 204.8 'Convert to Volt, assuming +/-10 Volt input range here
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		Label20.Text = VB6.Format(r, "#0.000") & "Volt"
		
		f = UltimaSerial.AnalogInput(ULTIMASERIALLib.enumAChn.Ch4) 'The binary reading from Channel 0
		f = f / 16 'Assuming 12-bit resolution. The data is left-justified
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		r = f / 204.8 'Convert to Volt, assuming +/-10 Volt input range here
		'UPGRADE_WARNING: Couldn't resolve default property of object r. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		Label21.Text = VB6.Format(r, "#0.000") & "Volt"
		
		If UltimaSerial.DigitalInput(ULTIMASERIALLib.enumDChn.Dig0) = 1 Then
			Label22.Text = "High"
			Shape1.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF) 'Red for high
		Else
			Label22.Text = "Low"
			Shape1.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF00) 'Green for low
		End If
		If UltimaSerial.DigitalInput(ULTIMASERIALLib.enumDChn.Dig1) = 1 Then
			Label23.Text = "High"
			Shape3.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF) 'Red for high
		Else
			Label23.Text = "Low"
			Shape3.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF00) 'Green for low
		End If
		If UltimaSerial.DigitalInput(ULTIMASERIALLib.enumDChn.Dig2) = 1 Then
			Label24.Text = "High"
			Shape4.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF) 'Red for high
		Else
			Label24.Text = "Low"
			Shape4.FillColor = System.Drawing.ColorTranslator.FromOle(&HFF00) 'Green for low
		End If
		
		Label25.Text = CStr(UltimaSerial.TransitionCounter(ULTIMASERIALLib.enumDChn.Dig0, ULTIMASERIALLib.enumEdge.Low2High))
		Label26.Text = CStr(UltimaSerial.TransitionCounter(ULTIMASERIALLib.enumDChn.Dig1, ULTIMASERIALLib.enumEdge.Low2High))
		Label27.Text = CStr(UltimaSerial.TransitionCounter(ULTIMASERIALLib.enumDChn.Dig2, ULTIMASERIALLib.enumEdge.Low2High))
		
		Label28.Text = CStr(UltimaSerial.TransitionCounter(ULTIMASERIALLib.enumDChn.Dig0, ULTIMASERIALLib.enumEdge.High2Low))
		Label29.Text = CStr(UltimaSerial.TransitionCounter(ULTIMASERIALLib.enumDChn.Dig1, ULTIMASERIALLib.enumEdge.High2Low))
		Label30.Text = CStr(UltimaSerial.TransitionCounter(ULTIMASERIALLib.enumDChn.Dig2, ULTIMASERIALLib.enumEdge.High2Low))
		
	End Sub
	
	Private Sub UltimaSerial_DriverError(ByVal eventSender As System.Object, ByVal eventArgs As AxULTIMASERIALLib._DUltimaSerialEvents_DriverErrorEvent) Handles UltimaSerial.DriverError
		Label3.Text = UltimaSerial.MapErrorMessage(eventArgs.ErrorCode)
	End Sub
	
	Private Sub UltimaSerial_NewData(ByVal eventSender As System.Object, ByVal eventArgs As AxULTIMASERIALLib._DUltimaSerialEvents_NewDataEvent) Handles UltimaSerial.NewData
        Dim v(,) As Short
        v = UltimaSerial.GetData() 'Get data
		DQChart1.Chart((v)) 'Chart all channels
		
	End Sub
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
		Timer1.Enabled = False
		Shape2.FillColor = System.Drawing.ColorTranslator.FromOle(&HFFFFFF)
		UltimaSerial.Stop()
		Label32.Text = "Stopped"
	End Sub
End Class